; TIP1143.LSP: W.LSP   Enhanced Window Selection   (c)1995, Jeff Hurst

(defun W (/ WT C1 C2 CHK GL EL BL TL SET NS LC S2)
 (textscr)
 (princ "\nEnter type(s) of entities to be selected by window.")
 (princ "\nPolyline/Line/Circle/Arc/Solids/Block name/Text/teXtstyle <EXIT>: ")
 (terpri)
 (while (and (/= WT 32)(/= WT 13))
  (setq WT (cadr (grread)) GL nil)
  (if (or (= WT 80)(= WT 112))(progn
   (princ "\nPolylines will be selected.")(setq GL "POLYLINE")(buildlist)))
  (if (or (= WT 76)(= WT 108))(progn
   (princ "\nLines will be selected.")(setq GL "LINE")(buildlist)))
  (if (or (= WT 65)(= WT 97))(progn
   (princ "\nArc's will be selected.")(setq GL "ARC")(buildlist)))
  (if (or (= WT 67)(= WT 99))(progn
   (princ "\nCircle's will be selected.")(setq gl "CIRCLE")(buildlist)))
  (if (or (= WT 66)(= WT 98))(progn
   (princ "\nNamed Block's will be selected.")(setq GL "BLOCK")(buildlist)))
  (if (or (= WT 84)(= WT 116))(progn
   (princ "\nText will be selected.")(setq GL "TEXT")(buildlist)))
  (if (or (= WT 88)(= WT 120))(progn
   (princ "\nNamed Textstyles will be selected.")(setq GL "STYLE")(buildlist)))
  (if (or (= WT 83)(= WT 115))(progn
   (princ "\nSolid's will be selected.")(setq GL "SOLID")(buildlist)))
  (if (and (= GL nil)(/= WT 32)(/= WT 13))
   (progn
    (princ "\007")(terpri)
    (princ "\nInvalid selection!")(terpri)
   )
  )
 )
 (graphscr)
 (setq C1 (getpoint "\nPick first corner..."))
 (princ " other corner...")
 (setq C2 (getcorner C1))
 (getset)
 (if SET 
  (command SET)
  (progn
   (princ "\007")(terpri)
   (princ "\nNothing found!")(terpri)
  )
 )
 (princ)
)

(defun buildlist ()
 (if (and (= CHK nil)(/= GL "BLOCK")(/= GL "STYLE"))(setq EL GL))
 (if (= CHK 1)(setq CHK 2))
 (if (and (/= EL nil)(= CHK nil)) (setq CHK 1))
 (if (and (= CHK 2)(/= GL nil)(/= GL "BLOCK")(/= GL "STYLE"))
  (setq EL (strcat EL "," GL)))
 (if (= GL "BLOCK")(setq BL (strcase (getstring "\nEnter block name: "))))
 (if (= GL "STYLE")(setq TL (strcase (getstring "\nEnter textstyle name: "))))
(princ)
)

(defun getset ()
 (if (and (/= EL nil)(/= BL nil)(/= TL nil))
  (progn
   (setq SET (ssget "w" C1 C2 (list (cons 0 EL)))
         NS (ssadd)
         S2 (ssget "w" C1 C2 (list (cons 2 BL)))
         LC 0
   )
   (if S2 
    (progn
     (repeat (sslength SET)
      (setq NS (ssadd (ssname SET LC) NS)
            LC (1+ LC))
     )
     (setq LC 0)
     (repeat (sslength S2)
      (setq NS (ssadd (ssname S2 LC) NS)
            LC (1+ LC))
     )
    )
   )
   (setq S2 (ssget "w" C1 C2 (list (cons 7 TL))) LC 0)
   (if S2
    (progn
     (repeat (sslength S2)
      (setq NS (ssadd (ssname S2 LC) NS)
             LC (1+ LC))
     )
    )
   )
   (setq SET NS)
  )
 )
 (if (and (= el NIL)(/= bl NIL)(/= tl NIL))
  (progn
   (setq SET (ssget "w" C1 C2 (list (cons 2 BL)))
         NS (ssadd)
         S2 (ssget "w" C1 C2 (list (cons 7 TL)))
         LC 0
   )
   (if S2 
    (progn
     (repeat (sslength SET)
      (setq NS (ssadd (ssname SET LC) NS)
            LC (1+ LC))
     )
     (setq LC 0)
     (repeat (sslength S2)
      (setq ns (ssadd (ssname S2 LC) NS)
            LC (1+ LC))
     )
     (setq SET NS)
    )
   )
  )
 )
 (if (and (= EL nil)(/= BL nil)(= TL nil))
  (setq SET (ssget "w" C1 C2 (list (cons 2 BL)))))
 (if (and (= EL nil)(= BL nil)(/= TL nil))
  (setq SET (ssget "w" C1 C2 (list (cons 7 TL)))))
 (if (and (/= EL nil)(= BL nil)(= TL nil))
  (setq SET (ssget "w" C1 C2 (list (cons 0 EL)))))
 (if (and (/= EL nil)(= BL nil)(/= TL nil))
  (progn
   (setq SET (ssget "w" C1 C2 (list (cons 0 EL)))
         NS (ssadd)
        S2 (ssget "w" C1 C2 (list (cons 7 TL)))
       LC 0
   )
   (if S2
    (progn
     (repeat (sslength SET)
      (setq NS (ssadd (ssname SET LC) NS)
            LC (1+ LC))
     )
     (setq LC 0)
     (repeat (sslength S2)
      (setq NS (ssadd (ssname S2 LC) NS)
            LC (1+ LC))
     )
     (setq SET NS)
    )
   )
  )
 )
 (if (and (/= EL nil)(/= BL nil)(= TL nil))
  (progn
   (setq SET (ssget "w" C1 C2 (list (cons 0 EL)))
         NS (ssadd)
       S2 (ssget "w" (list (cons 2 BL)))
      LC 0
   )
   (if S2
    (progn
     (repeat (sslength SET)
      (setq NS (ssadd (ssname SET LC) NS)
            LC (1+ LC))
     )
     (setq LC 0)
     (repeat (sslength S2)
      (setq NS (ssadd (ssname S2 LC) NS)
            LC (1+ LC))
     )
     (setq SET NS)
    )
   )
  )
 )
(princ)
)
(princ); end w.lsp
