; TIP1141.LSP: ROT.LSP   Rotate or Array   (c)1995, Paul-Andre Marleau

(defun C:ROT (/ SEL PT ANG ANG1 ANG2 NBC RESP)
   (setq OLDERR   *error*
   *error* MYERROR)
   (setq OCMD (getvar "CMDECHO"))
   (setvar "CMDECHO" 0)
   (prompt "\nSelect objects: ")
   (setq SEL (ssget))
   (initget 1)
   (setq PT (getpoint "\nBase point for array or rotation: "))
   (initget 1 "Reference")
   (setq ANG (getangle "\n<Rotation angle>/Reference: "))
   (if (= ANG "Reference") 
      (progn
         (setq ANG1 (getangle pt "\nReference angle <0>: "))
         (if (= ANG1 nil) (setq ANG1 0.0))
         (setq ANG2 (getangle PT "\nNew angle: "))
         (setq ANG (- ANG2 ANG1))
      )
   )
   (setq NBC (getint "\nNumber of copies for array <return for rotation>: "))
   (setq ANG (* (/ 180 pi) ANG))
   (if (= NBC nil) 
      (command "rotate" SEL "" PT ANG)
      (progn
         (if (< (* ANG NBC) 360)
            (command "array" SEL "" "polar" PT (+ NBC 1) (* ANG NBC) "y")
            (progn
               (princ "\nAngle and number of copies exceeds 360 degrees.")              
               (initget "Maximum Fit")
               (setq resp 
                  (getkword (strcat 
                        "\nMaximum number of copies that fit in 360 degrees: "
                        (rtos  (fix (/ 359.9 ANG))  2 0)
                     "\nUse <Maximum> number shown or Fit original number to 360 degrees? ")
                  )
               )
               (if (or (= "Maximum" RESP) (= nil RESP)) (setq NBC (fix (/ 359.9 ANG)) ))
               (if (= "Fit" RESP) (setq ANG 360))
               (command "array" SEL "" "polar" PT (+ NBC 1) (* ANG NBC) "y")
            )
         )
      )
   )
   (setvar "CMDECHO" OCMD)
   (setq *error* OLDERR)
   (princ)
); end rot.lsp
